Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Botan::CTR_BE Class Referencefinal

`#include <ctr.h>`

Inheritance diagram for Botan::CTR_BE:

## Public Member Functions
void | cipher (const uint8_t in[], uint8_t out[], size_t length) override
void | cipher1 (uint8_t buf[], size_t len)
void | clear () override
CTR_BE * | clone () const override
| CTR_BE (BlockCipher *cipher)
| CTR_BE (BlockCipher *cipher, size_t ctr_size)
template<typename Alloc >
void | decrypt (std::vector< uint8_t, Alloc > &inout)
size_t | default_iv_length () const override
template<typename Alloc >
void | encipher (std::vector< uint8_t, Alloc > &inout)
template<typename Alloc >
void | encrypt (std::vector< uint8_t, Alloc > &inout)
Key_Length_Specification | key_spec () const override
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const override
virtual std::string | provider () const
void | seek (uint64_t offset) override
void | set_iv (const uint8_t iv[], size_t iv_len) override
void | set_key (const SymmetricKey &key)
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const uint8_t key[], size_t length)
bool | valid_iv_length (size_t iv_len) const override
bool | valid_keylength (size_t length) const
virtual void | write_keystream (uint8_t out[], size_t len)

## Static Public Member Functions
static std::unique_ptr< StreamCipher > | create (const std::string &algo_spec, const std::string &provider="")
static std::unique_ptr< StreamCipher > | create_or_throw (const std::string &algo_spec, const std::string &provider="")
static std::vector< std::string > | providers (const std::string &algo_spec)

## Protected Member Functions
void | verify_key_set (bool cond) const

## Detailed Description

CTR-BE (Counter mode, big-endian)

Definition at line 21 of file ctr.h.

## Constructor & Destructor Documentation

Botan::CTR_BE::CTR_BE | ( | BlockCipher * | cipher | ) |
| explicit

Parameters

  cipher | the block cipher to use

Definition at line 15 of file ctr.cpp.

Referenced by clone().

15 :
16 m_cipher(ciph),
17 m_block_size(m_cipher->block_size()),
18 m_ctr_size(m_block_size),
19 m_ctr_blocks(m_cipher->parallel_bytes() / m_block_size),
20 m_counter(m_cipher->parallel_bytes()),
21 m_pad(m_counter.size()),
22 m_pad_pos(0)
23 {
24 }

Botan::CTR_BE::CTR_BE | ( | BlockCipher * | cipher,
|  | size_t | ctr_size
| ) |  |

Definition at line 26 of file ctr.cpp.

References BOTAN_ARG_CHECK.

26 :
27 m_cipher(cipher),
28 m_block_size(m_cipher->block_size()),
29 m_ctr_size(ctr_size),
30 m_ctr_blocks(m_cipher->parallel_bytes() / m_block_size),
31 m_counter(m_cipher->parallel_bytes()),
32 m_pad(m_counter.size()),
33 m_pad_pos(0)
34 {
35 BOTAN_ARG_CHECK(m_ctr_size >= 4 && m_ctr_size <= m_block_size,
36 "Invalid CTR-BE counter size");
37 }
BOTAN_ARG_CHECK
#define BOTAN_ARG_CHECK(expr, msg)
Definition: assert.h:37
Botan::CTR_BE::cipher
void cipher(const uint8_t in[], uint8_t out[], size_t length) override
Definition: ctr.cpp:85

## Member Function Documentation

void Botan::CTR_BE::cipher | ( | const uint8_t | in[],
|  | uint8_t | out[],
|  | size_t | len
| ) |  |
| override virtual

Encrypt or decrypt a message

Parameters

  in | the plaintext
  out | the byte array to hold the output, i.e. the ciphertext
  len | the length of both in and out in bytes

Implements Botan::StreamCipher.

Definition at line 85 of file ctr.cpp.

References Botan::SymmetricAlgorithm::verify_key_set(), and Botan::xor_buf().

86 {
87 verify_key_set(m_iv.empty() == false);
88
89 const uint8_t* pad_bits = &m_pad[0];
90 const size_t pad_size = m_pad.size();
91
92 if(m_pad_pos > 0)
93 {
94 const size_t avail = pad_size - m_pad_pos;
95 const size_t take = std::min(length, avail);
96 xor_buf(out, in, pad_bits + m_pad_pos, take);
97 length -= take;
98 in += take;
99 out += take;
100 m_pad_pos += take;
101
102 if(take == avail)
103 {
104 add_counter(m_ctr_blocks);
105 m_cipher->encrypt_n(m_counter.data(), m_pad.data(), m_ctr_blocks);
106 m_pad_pos = 0;
107 }
108 }
109
110 while(length >= pad_size)
111 {
112 xor_buf(out, in, pad_bits, pad_size);
113 length -= pad_size;
114 in += pad_size;
115 out += pad_size;
116
117 add_counter(m_ctr_blocks);
118 m_cipher->encrypt_n(m_counter.data(), m_pad.data(), m_ctr_blocks);
119 }
120
121 xor_buf(out, in, pad_bits, length);
122 m_pad_pos += length;
123 }
Botan::xor_buf
void xor_buf(uint8_t out[], const uint8_t in[], size_t length)
Definition: mem_ops.h:232
Botan::SymmetricAlgorithm::verify_key_set
void verify_key_set(bool cond) const
Definition: sym_algo.h:89

void Botan::StreamCipher::cipher1 | ( | uint8_t | buf[],
|  | size_t | len
| ) |  |
| inline inherited

Encrypt or decrypt a message The message is encrypted/decrypted in place.

Parameters

  buf | the plaintext / ciphertext
  len | the length of buf in bytes

Definition at line 78 of file stream_cipher.h.

Referenced by Botan::SIV_Encryption::finish().

79 { cipher(buf, buf, len); }
Botan::StreamCipher::cipher
virtual void cipher(const uint8_t in[], uint8_t out[], size_t len)=0

void Botan::CTR_BE::clear | ( |  | ) |
| override virtual

Reset the state.

Implements Botan::SymmetricAlgorithm.

Definition at line 39 of file ctr.cpp.

References Botan::zap(), and Botan::zeroise().

40 {
41 m_cipher->clear();
42 zeroise(m_pad);
43 zeroise(m_counter);
44 zap(m_iv);
45 m_pad_pos = 0;
46 }
Botan::zap
void zap(std::vector< T, Alloc > &vec)
Definition: secmem.h:170
Botan::zeroise
void zeroise(std::vector< T, Alloc > &vec)
Definition: secmem.h:160

CTR_BE * Botan::CTR_BE::clone | ( |  | ) | const
| override virtual

Returns
  a new object representing the same algorithm as *this

Implements Botan::StreamCipher.

Definition at line 63 of file ctr.cpp.

References CTR_BE().

64 {
65 return new CTR_BE(m_cipher->clone(), m_ctr_size);
66 }
Botan::CTR_BE::CTR_BE
CTR_BE(BlockCipher *cipher)
Definition: ctr.cpp:15

std::unique_ptr< StreamCipher > Botan::StreamCipher::create | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static inherited

Create an instance based on a name If provider is empty then best available is chosen.

Parameters

  algo_spec | algorithm name
  provider | provider implementation to use

Returns
  a null pointer if the algo/provider combination cannot be found

Definition at line 42 of file stream_cipher.cpp.

References Botan::SCAN_Name::algo_name(), Botan::SCAN_Name::arg(), Botan::SCAN_Name::arg_as_integer(), Botan::SCAN_Name::arg_count(), Botan::SCAN_Name::arg_count_between(), BOTAN_UNUSED, Botan::StreamCipher::cipher(), and Botan::BlockCipher::create().

Referenced by Botan::BlockCipher::create(), Botan::Cipher_Mode::create(), and Botan::StreamCipher::create_or_throw().

44 {
45 const SCAN_Name req(algo_spec);
46
47 #if defined(BOTAN_HAS_CTR_BE)
48 if((req.algo_name() == "CTR-BE" || req.algo_name() == "CTR") && req.arg_count_between(1,2))
49 {
50 if(provider.empty() || provider == "base")
51 {
52 auto cipher = BlockCipher::create(req.arg(0));
53 if(cipher)
54 {
55 size_t ctr_size = req.arg_as_integer(1, cipher->block_size());
56 return std::unique_ptr<StreamCipher>(new CTR_BE(cipher.release(), ctr_size));
57 }
58 }
59 }
60 #endif
61
62 #if defined(BOTAN_HAS_CHACHA)
63 if(req.algo_name() == "ChaCha")
64 {
65 if(provider.empty() || provider == "base")
66 return std::unique_ptr<StreamCipher>(new ChaCha(req.arg_as_integer(0, 20)));
67 }
68
69 if(req.algo_name() == "ChaCha20")
70 {
71 if(provider.empty() || provider == "base")
72 return std::unique_ptr<StreamCipher>(new ChaCha(20));
73 }
74 #endif
75
76 #if defined(BOTAN_HAS_SALSA20)
77 if(req.algo_name() == "Salsa20")
78 {
79 if(provider.empty() || provider == "base")
80 return std::unique_ptr<StreamCipher>(new Salsa20);
81 }
82 #endif
83
84 #if defined(BOTAN_HAS_SHAKE_CIPHER)
85 if(req.algo_name() == "SHAKE-128" || req.algo_name() == "SHAKE-128-XOF")
86 {
87 if(provider.empty() || provider == "base")
88 return std::unique_ptr<StreamCipher>(new SHAKE_128_Cipher);
89 }
90 #endif
91
92 #if defined(BOTAN_HAS_OFB)
93 if(req.algo_name() == "OFB" && req.arg_count() == 1)
94 {
95 if(provider.empty() || provider == "base")
96 {
97 if(auto c = BlockCipher::create(req.arg(0)))
98 return std::unique_ptr<StreamCipher>(new OFB(c.release()));
99 }
100 }
101 #endif
102
103 #if defined(BOTAN_HAS_RC4)
104
105 if(req.algo_name() == "RC4" ||
106 req.algo_name() == "ARC4" ||
107 req.algo_name() == "MARK-4")
108 {
109 const size_t skip = (req.algo_name() == "MARK-4") ? 256 : req.arg_as_integer(0, 0);
110
111 #if defined(BOTAN_HAS_OPENSSL)
112 if(provider.empty() || provider == "openssl")
113 {
114 return std::unique_ptr<StreamCipher>(make_openssl_rc4(skip));
115 }
116 #endif
117
118 if(provider.empty() || provider == "base")
119 {
120 return std::unique_ptr<StreamCipher>(new RC4(skip));
121 }
122 }
123
124 #endif
125
126 BOTAN_UNUSED(req);
127 BOTAN_UNUSED(provider);
128
129 return nullptr;
130 }
Botan::StreamCipher::cipher
virtual void cipher(const uint8_t in[], uint8_t out[], size_t len)=0
Botan::StreamCipher::provider
virtual std::string provider() const
Definition: stream_cipher.h:142
BOTAN_UNUSED
#define BOTAN_UNUSED(...)
Definition: assert.h:142
Botan::BlockCipher::create
static std::unique_ptr< BlockCipher > create(const std::string &algo_spec, const std::string &provider="")
Definition: block_cipher.cpp:108

std::unique_ptr< StreamCipher > Botan::StreamCipher::create_or_throw | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static inherited

Create an instance based on a name If provider is empty then best available is chosen.

Parameters

  algo_spec | algorithm name
  provider | provider implementation to use Throws a Lookup_Error if the algo/provider combination cannot be found

Definition at line 134 of file stream_cipher.cpp.

References Botan::StreamCipher::create().

Referenced by Botan::ChaCha_RNG::ChaCha_RNG(), Botan::Sodium::crypto_secretbox_detached(), Botan::Sodium::crypto_secretbox_open_detached(), Botan::Sodium::crypto_secretbox_xsalsa20poly1305(), Botan::Sodium::crypto_secretbox_xsalsa20poly1305_open(), Botan::Sodium::crypto_stream_chacha20(), Botan::Sodium::crypto_stream_chacha20_ietf(), Botan::Sodium::crypto_stream_chacha20_ietf_xor_ic(), Botan::Sodium::crypto_stream_chacha20_xor_ic(), Botan::Sodium::crypto_stream_xchacha20(), and Botan::Sodium::crypto_stream_xchacha20_xor_ic().

136 {
137 if(auto sc = StreamCipher::create(algo, provider))
138 {
139 return sc;
140 }
141 throw Lookup_Error("Stream cipher", algo, provider);
142 }
Botan::StreamCipher::provider
virtual std::string provider() const
Definition: stream_cipher.h:142
Botan::StreamCipher::create
static std::unique_ptr< StreamCipher > create(const std::string &algo_spec, const std::string &provider="")
Definition: stream_cipher.cpp:42
template<typename Alloc >

void Botan::StreamCipher::decrypt | ( | std::vector< uint8_t, Alloc > & | inout | ) |
| inline inherited

Decrypt a message in place The message is decrypted in place.

Parameters

  inout | the plaintext / ciphertext

Definition at line 105 of file stream_cipher.h.

106 { cipher(inout.data(), inout.data(), inout.size()); }
Botan::StreamCipher::cipher
virtual void cipher(const uint8_t in[], uint8_t out[], size_t len)=0

size_t Botan::CTR_BE::default_iv_length | ( |  | ) | const
| override virtual

Return the default (preferred) nonce length If this function returns 0, then this cipher does not support nonces

Reimplemented from Botan::StreamCipher.

Definition at line 48 of file ctr.cpp.

49 {
50 return m_block_size;
51 }
template<typename Alloc >

void Botan::StreamCipher::encipher | ( | std::vector< uint8_t, Alloc > & | inout | ) |
| inline inherited

Encrypt a message The message is encrypted/decrypted in place.

Parameters

  inout | the plaintext / ciphertext

Definition at line 87 of file stream_cipher.h.

88 { cipher(inout.data(), inout.data(), inout.size()); }
Botan::StreamCipher::cipher
virtual void cipher(const uint8_t in[], uint8_t out[], size_t len)=0
template<typename Alloc >

void Botan::StreamCipher::encrypt | ( | std::vector< uint8_t, Alloc > & | inout | ) |
| inline inherited

Encrypt a message The message is encrypted in place.

Parameters

  inout | the plaintext / ciphertext

Definition at line 96 of file stream_cipher.h.

97 { cipher(inout.data(), inout.data(), inout.size()); }
Botan::StreamCipher::cipher
virtual void cipher(const uint8_t in[], uint8_t out[], size_t len)=0

Key_Length_Specification Botan::CTR_BE::key_spec | ( |  | ) | const
| override virtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 58 of file ctr.cpp.

59 {
60 return m_cipher->key_spec();
61 }

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 38 of file sym_algo.h.

39 {
40 return key_spec().maximum_keylength();
41 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maximum allowed key length

Definition at line 46 of file sym_algo.h.

Referenced by botan_block_cipher_get_keyspec(), and botan_mac_get_keyspec().

47 {
48 return key_spec().minimum_keylength();
49 }
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

std::string Botan::CTR_BE::name | ( |  | ) | const
| override virtual

Returns
  the algorithm name

Implements Botan::SymmetricAlgorithm.

Definition at line 76 of file ctr.cpp.

References Botan::ASN1::to_string().

Referenced by set_iv().

77 {
78 if(m_ctr_size == m_block_size)
79 return ("CTR-BE(" + m_cipher->name() + ")");
80 else
81 return ("CTR-BE(" + m_cipher->name() + "," + std::to_string(m_ctr_size) + ")");
82
83 }
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:213

virtual std::string Botan::StreamCipher::provider | ( |  | ) | const
| inline virtual inherited

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented in Botan::ChaCha.

Definition at line 142 of file stream_cipher.h.

142 { return "base"; }

std::vector< std::string > Botan::StreamCipher::providers | ( | const std::string & | algo_spec | ) |
| static inherited

Returns
  list of available providers for this algorithm, empty if not available

Definition at line 144 of file stream_cipher.cpp.

145 {
146 return probe_providers_of<StreamCipher>(algo_spec, {"base", "openssl"});
147 }

void Botan::CTR_BE::seek | ( | uint64_t | offset | ) |
| override virtual

Set the offset and the state used later to generate the keystream

Parameters

  offset | the offset where we begin to generate the keystream

Implements Botan::StreamCipher.

Definition at line 197 of file ctr.cpp.

References Botan::buffer_insert(), Botan::copy_mem(), Botan::is_power_of_2(), Botan::load_be< uint32_t >(), Botan::store_be(), Botan::SymmetricAlgorithm::verify_key_set(), and Botan::zeroise().

Referenced by set_iv().

198 {
199 verify_key_set(m_iv.empty() == false);
200
201 const uint64_t base_counter = m_ctr_blocks * (offset / m_counter.size());
202
203 zeroise(m_counter);
204 buffer_insert(m_counter, 0, m_iv);
205
206 const size_t BS = m_block_size;
207
208 // Set m_counter blocks to IV, IV + 1, ... IV + n
209
210 if(m_ctr_size == 4 && BS >= 8)
211 {
212 const uint32_t low32 = load_be<uint32_t>(&m_counter[BS-4], 0);
213
214 if(m_ctr_blocks >= 4 && is_power_of_2(m_ctr_blocks))
215 {
216 size_t written = 1;
217 while(written < m_ctr_blocks)
218 {
219 copy_mem(&m_counter[written*BS], &m_counter[0], BS*written);
220 written *= 2;
221 }
222 }
223 else
224 {
225 for(size_t i = 1; i != m_ctr_blocks; ++i)
226 {
227 copy_mem(&m_counter[i*BS], &m_counter[0], BS - 4);
228 }
229 }
230
231 for(size_t i = 1; i != m_ctr_blocks; ++i)
232 {
233 const uint32_t c = static_cast<uint32_t>(low32 + i);
234 store_be(c, &m_counter[(BS-4)+i*BS]);
235 }
236 }
237 else
238 {
239 // do everything sequentially:
240 for(size_t i = 1; i != m_ctr_blocks; ++i)
241 {
242 buffer_insert(m_counter, i*BS, &m_counter[(i-1)*BS], BS);
243
244 for(size_t j = 0; j != m_ctr_size; ++j)
245 if(++m_counter[i*BS + (BS - 1 - j)])
246 break;
247 }
248 }
249
250 if(base_counter > 0)
251 add_counter(base_counter);
252
253 m_cipher->encrypt_n(m_counter.data(), m_pad.data(), m_ctr_blocks);
254 m_pad_pos = offset % m_counter.size();
255 }
Botan::store_be
void store_be(uint16_t in, uint8_t out[2])
Definition: loadstor.h:438
Botan::load_be< uint32_t >
uint32_t load_be< uint32_t >(const uint8_t in[], size_t off)
Definition: loadstor.h:179
Botan::is_power_of_2
constexpr bool is_power_of_2(T arg)
Definition: bit_ops.h:43
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:132
Botan::SymmetricAlgorithm::verify_key_set
void verify_key_set(bool cond) const
Definition: sym_algo.h:89
Botan::buffer_insert
size_t buffer_insert(std::vector< T, Alloc > &buf, size_t buf_offset, const T input[], size_t input_length)
Definition: secmem.h:80
Botan::zeroise
void zeroise(std::vector< T, Alloc > &vec)
Definition: secmem.h:160

void Botan::CTR_BE::set_iv | ( | const uint8_t | iv[],
|  | size_t | iv_len
| ) |  |
| override virtual

Resync the cipher using the IV

Parameters

  iv | the initialization vector
  iv_len | the length of the IV in bytes

Implements Botan::StreamCipher.

Definition at line 125 of file ctr.cpp.

References Botan::buffer_insert(), name(), seek(), valid_iv_length(), and Botan::zeroise().

126 {
127 if(!valid_iv_length(iv_len))
128 throw Invalid_IV_Length(name(), iv_len);
129
130 m_iv.resize(m_block_size);
131 zeroise(m_iv);
132 buffer_insert(m_iv, 0, iv, iv_len);
133
134 seek(0);
135 }
Botan::CTR_BE::name
std::string name() const override
Definition: ctr.cpp:76
Botan::CTR_BE::seek
void seek(uint64_t offset) override
Definition: ctr.cpp:197
Botan::buffer_insert
size_t buffer_insert(std::vector< T, Alloc > &buf, size_t buf_offset, const T input[], size_t input_length)
Definition: secmem.h:80
Botan::CTR_BE::valid_iv_length
bool valid_iv_length(size_t iv_len) const override
Definition: ctr.cpp:53
Botan::zeroise
void zeroise(std::vector< T, Alloc > &vec)
Definition: secmem.h:160

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 65 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_package(), Botan::aont_unpackage(), botan_block_cipher_set_key(), botan_cipher_set_key(), botan_mac_set_key(), Botan::Sodium::crypto_stream_salsa20(), Botan::Sodium::crypto_stream_salsa20_xor_ic(), Botan::Sodium::crypto_stream_xsalsa20(), Botan::Sodium::crypto_stream_xsalsa20_xor_ic(), Botan::FPE::fe1_decrypt(), Botan::FPE::fe1_encrypt(), and Botan::Sodium::randombytes_buf_deterministic().

66 {
67 set_key(key.begin(), key.length());
68 }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:65
template<typename Alloc >

void Botan::SymmetricAlgorithm::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Definition at line 71 of file sym_algo.h.

72 {
73 set_key(key.data(), key.size());
74 }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:65

void Botan::SymmetricAlgorithm::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 17 of file sym_algo.cpp.

References Botan::SymmetricAlgorithm::name(), and Botan::SymmetricAlgorithm::valid_keylength().

18 {
19 if(!valid_keylength(length))
20 throw Invalid_Key_Length(name(), length);
21 key_schedule(key, length);
22 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:56
Botan::SymmetricAlgorithm::name
virtual std::string name() const =0

bool Botan::CTR_BE::valid_iv_length | ( | size_t | iv_len | ) | const
| override virtual

Parameters

  iv_len | the length of the IV in bytes

Returns
  if the length is valid for this algorithm

Reimplemented from Botan::StreamCipher.

Definition at line 53 of file ctr.cpp.

Referenced by set_iv().

54 {
55 return (iv_len <= m_block_size);
56 }

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 56 of file sym_algo.h.

Referenced by Botan::aont_package(), Botan::aont_unpackage(), and Botan::SymmetricAlgorithm::set_key().

57 {
58 return key_spec().valid_keylength(length);
59 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

void Botan::SymmetricAlgorithm::verify_key_set | ( | bool | cond | ) | const
| inline protected inherited

Definition at line 89 of file sym_algo.h.

Referenced by Botan::Salsa20::cipher(), cipher(), Botan::RC4::cipher(), Botan::SHAKE_128_Cipher::cipher(), Botan::ChaCha::cipher(), Botan::SM4::decrypt_n(), Botan::AES_128::decrypt_n(), Botan::Noekeon::decrypt_n(), Botan::KASUMI::decrypt_n(), Botan::SEED::decrypt_n(), Botan::Camellia_128::decrypt_n(), Botan::DES::decrypt_n(), Botan::Blowfish::decrypt_n(), Botan::CAST_256::decrypt_n(), Botan::Twofish::decrypt_n(), Botan::IDEA::decrypt_n(), Botan::CAST_128::decrypt_n(), Botan::DESX::decrypt_n(), Botan::SHACAL2::decrypt_n(), Botan::XTEA::decrypt_n(), Botan::MISTY1::decrypt_n(), Botan::Serpent::decrypt_n(), Botan::Threefish_512::decrypt_n(), Botan::Lion::decrypt_n(), Botan::ARIA_128::decrypt_n(), Botan::Camellia_192::decrypt_n(), Botan::TripleDES::decrypt_n(), Botan::ARIA_192::decrypt_n(), Botan::Camellia_256::decrypt_n(), Botan::GOST_28147_89::decrypt_n(), Botan::AES_192::decrypt_n(), Botan::ARIA_256::decrypt_n(), Botan::AES_256::decrypt_n(), Botan::SHACAL2::encrypt_n(), Botan::SM4::encrypt_n(), Botan::IDEA::encrypt_n(), Botan::KASUMI::encrypt_n(), Botan::AES_128::encrypt_n(), Botan::MISTY1::encrypt_n(), Botan::Noekeon::encrypt_n(), Botan::CAST_128::encrypt_n(), Botan::SEED::encrypt_n(), Botan::CAST_256::encrypt_n(), Botan::DES::encrypt_n(), Botan::Blowfish::encrypt_n(), Botan::Twofish::encrypt_n(), Botan::Camellia_128::encrypt_n(), Botan::XTEA::encrypt_n(), Botan::DESX::encrypt_n(), Botan::Threefish_512::encrypt_n(), Botan::Serpent::encrypt_n(), Botan::Lion::encrypt_n(), Botan::ARIA_128::encrypt_n(), Botan::Camellia_192::encrypt_n(), Botan::TripleDES::encrypt_n(), Botan::ARIA_192::encrypt_n(), Botan::Camellia_256::encrypt_n(), Botan::GOST_28147_89::encrypt_n(), Botan::AES_192::encrypt_n(), Botan::ARIA_256::encrypt_n(), Botan::AES_256::encrypt_n(), Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), Botan::GHASH::ghash_update(), Botan::CFB_Encryption::process(), Botan::CFB_Decryption::process(), Botan::Salsa20::seek(), seek(), Botan::ChaCha::seek(), Botan::OCB_Mode::set_associated_data(), Botan::Salsa20::set_iv(), Botan::ChaCha::set_iv(), Botan::GHASH::update(), Botan::GHASH::update_associated_data(), and Botan::ChaCha::write_keystream().

90 {
91 if(cond == false)
92 throw_key_not_set_error();
93 }

virtual void Botan::StreamCipher::write_keystream | ( | uint8_t | out[],
|  | size_t | len
| ) |  |
| inline virtual inherited

Write keystream bytes to a buffer

Parameters

  out | the byte array to hold the keystream
  len | the length of out in bytes

Reimplemented in Botan::ChaCha.

Definition at line 66 of file stream_cipher.h.

References Botan::clear_mem().

Referenced by Botan::Sodium::crypto_stream_salsa20(), and Botan::Sodium::crypto_stream_xsalsa20().

67 {
68 clear_mem(out, len);
69 cipher1(out, len);
70 }
Botan::StreamCipher::cipher1
void cipher1(uint8_t buf[], size_t len)
Definition: stream_cipher.h:78
Botan::clear_mem
void clear_mem(T *ptr, size_t n)
Definition: mem_ops.h:112

The documentation for this class was generated from the following files:

- src/lib/stream/ctr/ctr.h
- src/lib/stream/ctr/ctr.cpp